package com.telerik.examples.examples.autocomplete;

import android.content.Context;
import android.graphics.drawable.Drawable;
import android.view.Display;
import android.view.LayoutInflater;
import android.view.ViewGroup;

import com.telerik.examples.examples.listview.PhotoItemData;
import com.telerik.widget.list.ListViewAdapter;
import com.telerik.widget.list.ListViewDataSourceAdapter;
import com.telerik.widget.list.ListViewHolder;

import java.util.List;
import java.util.Random;
import java.util.concurrent.ThreadLocalRandom;

public class CategoryAdapter extends ListViewAdapter {

    private Context context;
    private int itemLayoutId;
    private List<Drawable> initialItems;
    private int itemHeight;

    public CategoryAdapter(List items, Context context, int itemLayoutId, int itemHeight) {
        super(items);
        this.context = context;
        this.itemLayoutId = itemLayoutId;
        this.initialItems = items;
        this.itemHeight = itemHeight;
    }

    public void showRandomNumberItems() {
        Random rand = new Random();
        int randomNum = rand.nextInt(31);
        List<Drawable> items = this.initialItems.subList(0,randomNum);
        this.setItems(items);
    }

    @Override
    public ListViewHolder onCreateViewHolder(ViewGroup viewGroup, int viewType) {
        return new CategoryViewHolder(LayoutInflater.from(this.context).inflate(itemLayoutId, viewGroup, false), itemHeight);
    }

    @Override
    public void onBindViewHolder(ListViewHolder holder, int position) {
        CategoryViewHolder typedViewHolder = (CategoryViewHolder) holder;
        Drawable current = (Drawable) this.getItem(position);
        typedViewHolder.bind(current);
    }
}
