package com.telerik.examples.examples.autocomplete;

import com.telerik.examples.R;
import com.telerik.examples.examples.dataform.CancelButtonEditor;
import com.telerik.examples.examples.dataform.DataFormFragment;
import com.telerik.widget.dataform.engine.MailValidator;
import com.telerik.widget.dataform.engine.MinimumLengthValidator;
import com.telerik.widget.dataform.engine.NonEmptyValidator;
import com.telerik.widget.dataform.engine.NotifyPropertyChangedBase;
import com.telerik.widget.dataform.engine.RangeValidator;
import com.telerik.widget.dataform.visualization.annotations.DataFormEditorParams;
import com.telerik.widget.dataform.visualization.annotations.DataFormProperty;
import com.telerik.widget.dataform.visualization.annotations.DataFormValidatorParams;
import com.telerik.widget.dataform.visualization.editors.DataFormAutoCompleteEditor;
import com.telerik.widget.dataform.visualization.editors.DataFormDateEditor;
import com.telerik.widget.dataform.visualization.editors.DataFormNumberPickerEditor;
import com.telerik.widget.dataform.visualization.editors.DataFormRadAutoCompleteEditor;

import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Calendar;
import java.util.Date;

public class FlightForm extends NotifyPropertyChangedBase {

    private String[] from = { "Akureyri, AEY", "Goroka, GKA" };
    private String to = "Akureyri, AEY";
    private long date = Calendar.getInstance().getTimeInMillis();
    private int travelers = 1;
    private boolean search;

    @DataFormProperty(
            label = "From",
            index = 0,
            editor = DataFormRadAutoCompleteEditor.class
    )
    //additionalData = { "Akureyri, AEY", "Goroka, GKA" }

    public String[] getFrom() {
        return from;
    }
    public void setFrom(String[] value) {
        from = value;
        notifyListeners("From", value);
    }

    @DataFormProperty(label = "To", index = 1, editor = DataFormRadAutoCompleteEditor.class)
    public String getTo() {
        return to;
    }
    public void setTo(String value) {
        to = value;
        notifyListeners("To", value);
    }

    @DataFormProperty(label = "Date", index = 2, editor = DataFormDateEditor.class)
    public long getDate() {
        return date;
    }
    public void setDate(long value) {
        date = value;
        notifyListeners("Date", value);
    }

    @DataFormProperty(label = "Travelers", index = 3,editor = DataFormNumberPickerEditor.class)
    public int getTravelers() {
        return travelers;
    }

    public void setTravelers(int value) {
        travelers = value;
        notifyListeners("Travelers", value);
    }

    @DataFormProperty(label = "Search", index = 4, editor = ButtonEditor.class)
    public boolean getSearch() {
        return search;
    }

    public void setSearch(boolean value) {
        this.search = value;
    }

}
