                                                                                                                                                    package com.telerik.examples.examples.gauges;

import android.graphics.Color;
import android.os.Bundle;
import android.os.Handler;
import android.support.annotation.Nullable;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;

import com.telerik.android.common.Util;
import com.telerik.examples.R;
import com.telerik.examples.common.fragments.ExampleFragmentBase;
import com.telerik.widget.gauge.RadRadialGaugeView;
import com.telerik.widget.indicators.GaugeBarIndicatorCapMode;
import com.telerik.widget.indicators.GaugeRadialBarIndicator;
import com.telerik.widget.scales.GaugeRadialScale;
import com.telerik.widget.scales.GaugeScaleLabelsLayoutMode;
import java.util.Random;

                                                                                                                                                    public class RadialBarsExample extends ExampleFragmentBase {
    RadRadialGaugeView topLeftGauge;
    RadRadialGaugeView topRightGauge;
    RadRadialGaugeView bottomLeftGauge;

    GaugeRadialBarIndicator topLeftGaugeOrangeBar;
    GaugeRadialBarIndicator topLeftGaugeGreenBar;
    GaugeRadialBarIndicator topLeftGaugeBlueBar;
    GaugeRadialBarIndicator topRightGaugeBar;
    GaugeRadialBarIndicator bottomGaugeRedBar;

    Handler timerHandler = new Handler();
    Runnable timerRunnable = new Runnable() {
        @Override
        public void run() {
            setGaugeValues();
            timerHandler.postDelayed(this, 2000);
        }
    };

    @Nullable
    @Override
    public View onCreateView(LayoutInflater inflater, @Nullable ViewGroup container, @Nullable Bundle savedInstanceState) {
        View rootView = inflater.inflate(R.layout.radial_gauge_bars_gallery, container, false);
        topLeftGauge = Util.getLayoutPart(rootView, R.id.top_left_gauge, RadRadialGaugeView.class);
        topRightGauge = Util.getLayoutPart(rootView, R.id.top_right_gauge, RadRadialGaugeView.class);
        bottomLeftGauge = Util.getLayoutPart(rootView, R.id.bottom_left_gauge, RadRadialGaugeView.class);
        setupTopLeftGauge();
        setupTopRightGauge();
        setupBottomLeftGauge();
        return rootView;
    }

    @Override
    public void onStart() {
        super.onStart();
        timerHandler.postDelayed(timerRunnable, 0);
    }

    @Override
    public void onPause() {
        super.onPause();
        timerHandler.removeCallbacks(timerRunnable);
    }

    private void setupTopLeftGauge() {
        GaugeRadialScale scale = new GaugeRadialScale(getActivity());
        scale.setStartAngle(-90);
        scale.setSweepAngle(360);
        scale.setLabelsVisible(false);
        scale.setTicksVisible(false);
        scale.setLineVisible(false);
        topLeftGauge.addScale(scale);

        GaugeRadialBarIndicator grayBar = new GaugeRadialBarIndicator(getActivity());
        grayBar.setCap(GaugeBarIndicatorCapMode.ROUND);
        grayBar.setLocation(0.95f);
        grayBar.setBarWidth(0.2f);
        grayBar.setRange(0, 100);
        grayBar.setFillColor(Color.rgb(221, 221, 221));
        scale.addIndicator(grayBar);

        topLeftGaugeOrangeBar = new GaugeRadialBarIndicator(getActivity());
        topLeftGaugeOrangeBar.setAnimated(true);
        topLeftGaugeOrangeBar.setCap(GaugeBarIndicatorCapMode.ROUND);
        topLeftGaugeOrangeBar.setLocation(0.95f);
        topLeftGaugeOrangeBar.setBarWidth(0.2f);
        topLeftGaugeOrangeBar.setRange(0, 80);
        topLeftGaugeOrangeBar.setFillColor(Color.rgb(222, 158, 38));
        scale.addIndicator(topLeftGaugeOrangeBar);

        topLeftGaugeGreenBar = new GaugeRadialBarIndicator(getActivity());
        topLeftGaugeGreenBar.setAnimated(true);
        topLeftGaugeGreenBar.setCap(GaugeBarIndicatorCapMode.ROUND);
        topLeftGaugeGreenBar.setLocation(0.95f);
        topLeftGaugeGreenBar.setBarWidth(0.2f);
        topLeftGaugeGreenBar.setRange(0, 55);
        topLeftGaugeGreenBar.setFillColor(Color.rgb(163, 213, 84));
        scale.addIndicator(topLeftGaugeGreenBar);

        topLeftGaugeBlueBar = new GaugeRadialBarIndicator(getActivity());
        topLeftGaugeBlueBar.setAnimated(true);
        topLeftGaugeBlueBar.setCap(GaugeBarIndicatorCapMode.ROUND);
        topLeftGaugeBlueBar.setLocation(0.95f);
        topLeftGaugeBlueBar.setBarWidth(0.2f);
        topLeftGaugeBlueBar.setRange(0, 40);
        topLeftGaugeBlueBar.setFillColor(Color.rgb(33, 197, 254));
        scale.addIndicator(topLeftGaugeBlueBar);
    }

    private void setupTopRightGauge() {
        GaugeRadialScale scale = new GaugeRadialScale(getActivity());
        scale.setRadius(0.75f);
        scale.setRange(0, 180);
        scale.setStartAngle(135);
        scale.setSweepAngle(270);
        scale.setLineVisible(false);

        scale.setMajorTicksCount(19);
        scale.setMinorTicksCount(0);
        scale.setMajorTicksWidth(6);
        scale.setMajorTicksHeight(6);
        scale.setMajorTicksFillColor(Color.GRAY);

        scale.setLabelsLayoutMode(GaugeScaleLabelsLayoutMode.OUTER);
        scale.getLabelsPaint().setTextSize(getResources().getDimension(R.dimen.gauge_scale_label_size));
        scale.setLabelsOffset(getResources().getDimension(R.dimen.gauge_scale_label_offset));
        scale.setLabelsCount(10);
        topRightGauge.addScale(scale);

        topRightGaugeBar = new GaugeRadialBarIndicator(getActivity());
        topRightGaugeBar.setAnimated(true);
        topRightGaugeBar.setRange(0, 120);
        topRightGaugeBar.setLocation(0.7f);
        topRightGaugeBar.setFillColor(Color.rgb(33, 197, 254));
        topRightGaugeBar.setBarWidth(0.09f);
        scale.addIndicator(topRightGaugeBar);

        topRightGauge.getTitle().setText("120");
        topRightGauge.getTitle().setTextColor(Color.rgb(33, 197, 254));
        topRightGauge.getTitle().setTextSize(20);
    }

    private void setupBottomLeftGauge() {
        GaugeRadialScale scale = new GaugeRadialScale(getActivity());
        scale.setStartAngle(180);
        scale.setSweepAngle(180);
        scale.setTicksVisible(false);
        scale.setLabelsVisible(false);
        scale.setLineVisible(false);
        bottomLeftGauge.addScale(scale);

        GaugeRadialBarIndicator grayBar = new GaugeRadialBarIndicator(getActivity());
        grayBar.setFillColor(Color.rgb(221, 221, 221));
        grayBar.setRange(0, 100);
        grayBar.setBarWidth(0.5f);
        scale.addIndicator(grayBar);

        bottomGaugeRedBar = new GaugeRadialBarIndicator(getActivity());
        bottomGaugeRedBar.setAnimated(true);
        bottomGaugeRedBar.setFillColor(Color.RED);
        bottomGaugeRedBar.setRange(0, 60);
        bottomGaugeRedBar.setBarWidth(0.5f);
        scale.addIndicator(bottomGaugeRedBar);

        bottomLeftGauge.getTitle().setText("60");
        bottomLeftGauge.getTitle().setTextColor(Color.RED);
        bottomLeftGauge.getTitle().setTextSize(20);
        bottomLeftGauge.setTitleVerticalOffset(getResources().getDimension(R.dimen.gauge_title_vertical_offset));
    }

    private void setGaugeValues() {
        Random r = new Random();
        bottomGaugeRedBar.setMaximum(r.nextInt(100));
        bottomLeftGauge.getTitle().setText(String.format(getResources().getConfiguration().locale,"%.0f", bottomGaugeRedBar.getMaximum()));
        topRightGaugeBar.setMaximum(r.nextInt(180));
        topRightGauge.getTitle().setText(String.format(getResources().getConfiguration().locale,"%.0f", topRightGaugeBar.getMaximum()));
        topLeftGaugeBlueBar.setMaximum(r.nextInt(40));
        topLeftGaugeGreenBar.setMaximum(topLeftGaugeBlueBar.getMaximum() + r.nextInt(55 - Math.round(topLeftGaugeBlueBar.getMaximum())));
        topLeftGaugeOrangeBar.setMaximum(topLeftGaugeGreenBar.getMaximum() + r.nextInt(80 - Math.round(topLeftGaugeGreenBar.getMaximum())));
    }
}
